/*
 * global.h
 *
 * Created: 27.11.2014 12:35:21
 *  Author: Prophecy
 */ 


#ifndef GLOBAL_H_
#define GLOBAL_H_


//ISR-variablen
volatile uint8_t	BAM_data_red0[BAM_BITS];		//ISR BAM-Port daten / array = bitweise aufsteigend (array[0]-LSB = erstes BAM-bit vom ersten channel, array[1]-LSB = zweites BAM-bit vom ersten channel)
volatile uint8_t	BAM_data_green0[BAM_BITS];
volatile uint8_t	BAM_data_blue0[BAM_BITS];	//anoden zeile 0

volatile uint8_t	BAM_data_red1[BAM_BITS];		//anoden zeile 1
volatile uint8_t	BAM_data_green1[BAM_BITS];
volatile uint8_t	BAM_data_blue1[BAM_BITS];

volatile uint8_t	BAM_data_red2[BAM_BITS];		//anoden zeile 2
volatile uint8_t	 BAM_data_green2[BAM_BITS];
volatile uint8_t	BAM_data_blue2[BAM_BITS];

volatile uint8_t	BAM_data_red3[BAM_BITS];		//anoden zeile 3
volatile uint8_t	BAM_data_green3[BAM_BITS];
volatile uint8_t	BAM_data_blue3[BAM_BITS];

volatile uint8_t	BAM_data_red4[BAM_BITS];		//anoden zeile 4
volatile uint8_t	BAM_data_green4[BAM_BITS];
volatile uint8_t	BAM_data_blue4[BAM_BITS];

volatile uint8_t	BAM_data_red5[BAM_BITS];		//anoden zeile 5
volatile uint8_t	BAM_data_green5[BAM_BITS];
volatile uint8_t	BAM_data_blue5[BAM_BITS];

volatile uint8_t	BAM_data_red6[BAM_BITS];		//anoden zeile 6
volatile uint8_t	BAM_data_green6[BAM_BITS];
volatile uint8_t	BAM_data_blue6[BAM_BITS];

volatile uint8_t	row_active;
volatile uint8_t	higher_bits_flag;

struct 
{
	uint8_t not_over_sound_limit:1;
	uint8_t	screensaver:1;
} volatile status_flags;

uint16_t led_brightness_red[rows][columns];		//belichtungswert RGB der leds
uint16_t led_brightness_green[rows][columns];
uint16_t led_brightness_blue[rows][columns];


uint8_t RandomL,RandomH;



void init_matrix_data(void);
void BAM_set(void);
void set_led_red (uint8_t row, uint8_t column, uint16_t val);
void set_led_green (uint8_t row, uint8_t column, uint16_t val);
void set_led_blue (uint8_t row, uint8_t column, uint16_t val);
void set_led_rgb(uint8_t row, uint8_t column, uint16_t red, uint16_t green, uint16_t blue);
void set_matrix_rgb(uint16_t red, uint16_t green, uint16_t blue);
void set_matrix_hue(uint16_t hue);
void set_led_hue(uint8_t row, uint8_t column, uint16_t hue);
void set_column_hue(uint16_t hue, uint8_t column);
void set_row_hue(uint16_t hue, uint8_t row);
void set_all_random(void);
unsigned short prandom(void);
unsigned long prandom23(void);

#endif /* GLOBAL_H_ */